SystemOrganization addCategory: #'Stack-Exercise'!

Object subclass: #OOStack
	instanceVariableNames: 'firstItem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!OOStack class methodsFor: 'error descriptions' stamp: 'HernanWilkinson 5/7/2012 11:51'!
stackEmptyErrorDescription
	
	^ 'Stack is empty'! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/6/2013 20:37'!
initialize
	firstItem := EmptyOOStackItem new.
	
! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/6/2013 20:38'!
isEmpty
	^ firstItem isEmpty ! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/6/2013 20:39'!
pop
	|elem|
	elem := self top.
	firstItem := firstItem pop.
	^ elem
! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/6/2013 20:40'!
push: aByteString 
	firstItem := (firstItem push: aByteString )! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/6/2013 20:40'!
size
	^ firstItem size! !

!OOStack methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/6/2013 20:41'!
top
	^ firstItem top! !

Object subclass: #OOStackItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

OOStackItem subclass: #EmptyOOStackItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!EmptyOOStackItem methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/6/2013 20:49'!
isEmpty 
	^ true! !

!EmptyOOStackItem methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/6/2013 20:42'!
pop
	^ Error signal: 'Stack is empty' ! !

!EmptyOOStackItem methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/6/2013 20:49'!
size
	^ 0! !

!EmptyOOStackItem methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/6/2013 19:59'!
top
	^ Error signal: 'Stack is empty' ! !

OOStackItem subclass: #NonEmptyOOStackItem
	instanceVariableNames: 'value nextStackItem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

NonEmptyOOStackItem class
	instanceVariableNames: 'value'!

NonEmptyOOStackItem class
	instanceVariableNames: 'value'!

!NonEmptyOOStackItem class methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/6/2013 21:10'!
createWithValue: aByteString andPrevious: anOOStackItem
	|elem|
	elem := NonEmptyOOStackItem new.
	elem initializeWithValue: aByteString  andPrevious: anOOStackItem.
	^ elem ! !

!NonEmptyOOStackItem methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/6/2013 21:00'!
initializeWithValue: aByteString andPrevious: anOOStackItem
	value := aByteString .
	nextStackItem := anOOStackItem 
	! !

!NonEmptyOOStackItem methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/6/2013 20:50'!
isEmpty 
	^ false! !

!NonEmptyOOStackItem methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/6/2013 20:52'!
pop
	^ nextStackItem! !

!NonEmptyOOStackItem methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/6/2013 20:53'!
size 
	^ 1 + (nextStackItem size)! !

!NonEmptyOOStackItem methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/6/2013 20:29'!
top
	^ value! !

!OOStackItem methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/6/2013 21:12'!
isEmpty 
	^ self subclassResponsibility ! !

!OOStackItem methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/6/2013 21:13'!
pop
	^ self subclassResponsibility ! !

!OOStackItem methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/6/2013 21:04'!
push: aByteString 
	^ NonEmptyOOStackItem createWithValue: aByteString andPrevious: self .
! !

!OOStackItem methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/6/2013 21:13'!
size 
	^ self subclassResponsibility ! !

!OOStackItem methodsFor: 'as yet unclassified' stamp: 'EtchegoyenLajePulver 5/6/2013 20:12'!
top
	self subclassResponsibility ! !

TestCase subclass: #OOStackTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Stack-Exercise'!

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:30'!
test01StackShouldBeEmptyWhenCreated

	| stack |
	
	stack := OOStack new.
	
	self assert: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:30'!
test02PushAddElementsToTheStack

	| stack |
	
	stack := OOStack new.
	stack push: 'Something'.
	
	self deny: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:31'!
test03PopRemovesElementsFromTheStack

	| stack |
	
	stack := OOStack new.
	stack push: 'Something'.
	stack pop.
	
	self assert: stack isEmpty! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/8/2012 08:20'!
test04PopReturnsLastPushedObject

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	stack push: pushedObject.
	
	self assert: stack pop = pushedObject! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:33'!
test05StackBehavesLIFO

	| stack firstPushedObject secondPushedObject |
	
	stack := OOStack new.
	firstPushedObject := 'First'.
	secondPushedObject := 'Second'.
	
	stack push: firstPushedObject.
	stack push: secondPushedObject.
	
	self assert: stack pop = secondPushedObject.
	self assert: stack pop = firstPushedObject.
	self assert: stack isEmpty 
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:35'!
test06TopReturnsLastPushedObject

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	
	stack push: pushedObject.
	
	self assert: stack top = pushedObject.
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:36'!
test07TopDoesNotRemoveObjectFromStack

	| stack pushedObject |
	
	stack := OOStack new.
	pushedObject := 'Something'.
	
	stack push: pushedObject.
	
	self assert: stack size = 1.
	stack top.
	self assert: stack size = 1.
	! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/7/2012 11:38'!
test08CanNotPopWhenThereAreNoObjectsInTheStack

	| stack  |
	
	stack := OOStack new.
	self
		should: [ stack pop ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/16/2012 16:53'!
test09CanNotPopWhenThereAreNoObjectsInTheStackAndTheStackHadObjects

	| stack  |
	
	stack := OOStack new.
	stack push: 'Something'.
	stack pop.
	
	self
		should: [ stack pop ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !

!OOStackTest methodsFor: 'test' stamp: 'HernanWilkinson 5/16/2012 16:53'!
test10CanNotTopWhenThereAreNoObjectsInTheStack

	| stack  |
	
	stack := OOStack new.
	self
		should: [ stack top ]
		raise: Error
		withExceptionDo: [ :anError |
			self assert: anError messageText = OOStack stackEmptyErrorDescription ]
		
! !
